<template lang="pug">
q-table.ui-table(
	title-class="q-py-xs q-pr-md"
	row-key="id"
	:rows-per-page-options="rowsPerPage"
	v-bind="$props",
	:columns="modelColumns"
	v-model:pagination="modelPagination"
	:rows="items"
	binary-state-sort
	@request="onRequest"
	@row-dblclick="onDblclick"
)
	template(#loading)
		q-inner-loading(showing, color="primary")

	template(#top-right)
		.row.q-py-xs.items-center
			slot(name="add")

	template(#top-left="props")
		slot(name="filter" :props="props")

	template(#body-cell-action="props")
		slot(name="action" :props="props")

//-q-pagination(
	v-model="pagination.page"
	v-bind:max="pagination.totalPages"
	direction-links
	boundary-numbers
	v-bind:max-pages="7"
	)

</template>

<script>
	import { computed, defineComponent, onMounted, ref, reactive } from 'vue'

	export default defineComponent({
		name: 'UiTable',

		props: {
			loading: {
				type: Boolean,
				default: false,
			},

			items: {
				type: Array,
				default: undefined,
			},

			columns: {
				type: Array,
				default: undefined,
			},

			pagination: {
				type: Object,
				default: () => {},
			},

			filter: {
				type: Object,
				default: () => {},
			},
		},

		emits: ['request', 'dblclick', 'update:pagination'],

		setup(props, { emit }) {
			return {
				rowsPerPage: [10, 30, 50, 100],

				modelPagination: computed({
					get: () => props.pagination,
					set: (value) => {
						emit('update:pagination', value)
					},
				}),

				modelColumns: reactive([
					...props.columns,
					{
						name: 'action',
						label: '',
						align: 'right',
						field: 'action',
						sortable: false,
					},
				]),

				onRequest(e) {
					emit('request', e)
				},

				onDblclick(evt, row, index) {
					emit('dblclick', row)
				},
			}
		},
	})
</script>

<style lang="scss" scoped>
	.q-table__container {
		max-height: calc(100vh - 150px);
		min-height: 300px;

		&:deep(tr) {
			.q-td__control {
				opacity: 0;
			}

			&:hover {
				.q-td__control {
					opacity: 1;
				}
			}
		}

		&:deep(.q-table) {
			td:last-child {
				background-color: transparent;
			}

			tbody tr:hover {
				td:last-child {
					position: sticky;
					right: 0;
					z-index: 1;
				}
			}

			.q-table__top,
			.q-table__bottom,
			thead tr:first-child th {
				background-color: #fff;
			}

			thead tr th {
				position: sticky;
				z-index: 2;
			}

			thead tr:first-child th {
				top: 0;
			}
		}
	}

	.ui-table {
	}
</style>
